/* GtkamlCodeContext.c generated by valac, the Vala compiler
 * generated from GtkamlCodeContext.vala, do not modify */

/* GtkamlCodeContext.vala
 * 
 * Copyright (C) 2006-2009  Jürg Billeter
 * Copyright (C) 1996-2002, 2004, 2005, 2006 Free Software Foundation, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 * Adapted for Gtkaml:
 *	Vlad Grecescu <b100dian@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <vala.h>
#include <valagee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>


#define GTKAML_TYPE_CODE_CONTEXT (gtkaml_code_context_get_type ())
#define GTKAML_CODE_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTKAML_TYPE_CODE_CONTEXT, GtkamlCodeContext))
#define GTKAML_CODE_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GTKAML_TYPE_CODE_CONTEXT, GtkamlCodeContextClass))
#define GTKAML_IS_CODE_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTKAML_TYPE_CODE_CONTEXT))
#define GTKAML_IS_CODE_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GTKAML_TYPE_CODE_CONTEXT))
#define GTKAML_CODE_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTKAML_TYPE_CODE_CONTEXT, GtkamlCodeContextClass))

typedef struct _GtkamlCodeContext GtkamlCodeContext;
typedef struct _GtkamlCodeContextClass GtkamlCodeContextClass;
typedef struct _GtkamlCodeContextPrivate GtkamlCodeContextPrivate;
#define _vala_collection_object_unref0(var) ((var == NULL) ? NULL : (var = (vala_collection_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GtkamlCodeContext {
	ValaCodeContext parent_instance;
	GtkamlCodeContextPrivate * priv;
	ValaList* generated_files;
};

struct _GtkamlCodeContextClass {
	ValaCodeContextClass parent_class;
};


static gpointer gtkaml_code_context_parent_class = NULL;

GType gtkaml_code_context_get_type (void);
enum  {
	GTKAML_CODE_CONTEXT_DUMMY_PROPERTY
};
void gtkaml_code_context_remove_generated_files (GtkamlCodeContext* self);
GtkamlCodeContext* gtkaml_code_context_new (void);
GtkamlCodeContext* gtkaml_code_context_construct (GType object_type);
static void gtkaml_code_context_finalize (ValaCodeContext* obj);



void gtkaml_code_context_remove_generated_files (GtkamlCodeContext* self) {
	g_return_if_fail (self != NULL);
	if (!vala_code_context_get_save_temps ((ValaCodeContext*) self)) {
		{
			ValaIterator* _filename_it;
			_filename_it = vala_iterable_iterator ((ValaIterable*) self->generated_files);
			while (TRUE) {
				char* filename;
				if (!vala_iterator_next (_filename_it)) {
					break;
				}
				filename = (char*) vala_iterator_get (_filename_it);
				g_unlink (filename);
				_g_free0 (filename);
			}
			_vala_collection_object_unref0 (_filename_it);
		}
	}
}


GtkamlCodeContext* gtkaml_code_context_construct (GType object_type) {
	GtkamlCodeContext* self;
	self = (GtkamlCodeContext*) vala_code_context_construct (object_type);
	return self;
}


GtkamlCodeContext* gtkaml_code_context_new (void) {
	return gtkaml_code_context_construct (GTKAML_TYPE_CODE_CONTEXT);
}


static void gtkaml_code_context_class_init (GtkamlCodeContextClass * klass) {
	gtkaml_code_context_parent_class = g_type_class_peek_parent (klass);
	VALA_CODE_CONTEXT_CLASS (klass)->finalize = gtkaml_code_context_finalize;
}


static void gtkaml_code_context_instance_init (GtkamlCodeContext * self) {
	self->generated_files = (ValaList*) vala_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, g_direct_equal);
}


static void gtkaml_code_context_finalize (ValaCodeContext* obj) {
	GtkamlCodeContext * self;
	self = GTKAML_CODE_CONTEXT (obj);
	_vala_collection_object_unref0 (self->generated_files);
	VALA_CODE_CONTEXT_CLASS (gtkaml_code_context_parent_class)->finalize (obj);
}


GType gtkaml_code_context_get_type (void) {
	static GType gtkaml_code_context_type_id = 0;
	if (gtkaml_code_context_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GtkamlCodeContextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gtkaml_code_context_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GtkamlCodeContext), 0, (GInstanceInitFunc) gtkaml_code_context_instance_init, NULL };
		gtkaml_code_context_type_id = g_type_register_static (VALA_TYPE_CODE_CONTEXT, "GtkamlCodeContext", &g_define_type_info, 0);
	}
	return gtkaml_code_context_type_id;
}




